﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;

using VidyaVitamin.Plugin;

namespace EditorPluginTest
{
	public partial class SampleForm : Form, IVVForm
	{
		private PropertyGrid pgrid;
		private ComboBox cbox;
		private SampleProp sample;

		public SampleForm(string path, ComboBox cbox, PropertyGrid pgrid)
		{
			InitializeComponent();

			this.cbox = cbox;
			cbox.DrawItem += new DrawItemEventHandler(cbox_DrawItem);
			this.pgrid = pgrid;
			sample = new SampleProp();

			if (path != null) textBox1.Text = File.ReadAllText(path);

			UpdateComboBox();
		}

		void cbox_DrawItem(object sender, DrawItemEventArgs e)
		{
			if (EditorPlugin.u != null && EditorPlugin.u.MainForm.ActiveMdiChild == this) {
				// コンボボックスのアイテム描画
				e.Graphics.DrawString(cbox.Items[e.Index].ToString(), cbox.Font,
					SystemBrushes.WindowText, e.Bounds.Location);
			}
		}

		public ToolStrip MainToolStrip
		{
			get { return null; }
		}

		public ToolStrip SubToolStrip
		{
			get { return null; }
		}

		public StatusStrip StatusStrip
		{
			get { return null; }
		}

		public TreeNode ProjectNode
		{
			get {return null; }
		}

		public EnableType EnableMenus
		{
			get { return EnableType.Save; }
		}

		public void OnClickSave(bool saveas)
		{
			SaveFileDialog dlg = new SaveFileDialog();
			if (dlg.ShowDialog() == DialogResult.Cancel) return;
			File.WriteAllText(dlg.FileName, textBox1.Text);
		}

		public void OnClickPrint()
		{
		}

		protected override void OnActivated(EventArgs e)
		{
			pgrid.SelectedObject = sample;

			UpdateComboBox();
			base.OnActivated(e);
		}

		private void UpdateComboBox()
		{
			cbox.Items.Clear();
			cbox.Items.Add("sample");
		}
	}

	public class SampleProp
	{
		private bool sample = false;
		public bool Sample
		{
			get { return sample; }
			set { sample = value; }
		}
	}
}
